import { FC } from 'react';
import { GestureResponderEvent, StyleProp, ViewStyle } from 'react-native';
import { ListItemProps } from '@procyon/components/ListItem';
export type ListData = {
    id: string;
    value: string;
};
export type ListProps = {
    Item?: FC<ListItemProps>;
    color?: 'primary' | 'secondary' | 'positive' | 'negative';
    compact?: boolean;
    data: ListData[];
    mode?: 'view' | 'interactive';
    onClick?: (event: GestureResponderEvent, value: string) => void;
    selected?: string;
    size?: 'sm' | 'md' | 'lg' | 'xl';
    style?: {
        container?: StyleProp<ViewStyle>;
        list?: StyleProp<ViewStyle>;
    };
};
export declare const List: FC<ListProps>;
