import React, { FC, ReactNode } from 'react';
import { StyleProp, View, ViewProps } from 'react-native';
import { ListProps } from '@procyon/components/List';
export type ListItemProps = {
    children: ReactNode;
    id: string;
    selected?: boolean;
    style?: {
        container?: StyleProp<ViewProps>;
    };
} & Omit<ListProps, 'selected' | 'data' | 'style'>;
export declare const ListItem: FC<ListItemProps>;
export declare const ListItemView: import("@emotion/native").StyledComponent<ViewProps & {
    theme?: import("@emotion/react").Theme | undefined;
    as?: React.ElementType<any, keyof React.JSX.IntrinsicElements> | undefined;
}, {}, {
    ref?: React.Ref<View> | undefined;
}>;
export declare const ListItemText: import("@emotion/native").StyledComponent<import("react-native").TextProps & {
    theme?: import("@emotion/react").Theme | undefined;
    as?: React.ElementType<any, keyof React.JSX.IntrinsicElements> | undefined;
} & {
    color?: ListItemProps['color'];
    size?: ListItemProps['size'];
}, {}, {
    ref?: React.Ref<import("react-native").Text> | undefined;
}>;
