"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListItemText = exports.ListItemView = exports.ListItem = void 0;
const react_1 = __importStar(require("react"));
const native_1 = __importDefault(require("@emotion/native"));
const react_2 = require("@emotion/react");
const react_native_reanimated_1 = require("react-native-reanimated");
const values_js_1 = __importDefault(require("values.js"));
const RippleEffect_1 = require("@procyon/components/RippleEffect");
const color_1 = require("@procyon/utils/color");
const debounce_1 = require("@procyon/utils/debounce");
const ListItem = ({ id, style, size = 'md', mode, onClick, children, color = 'primary', selected, }) => {
    const rippleAnimationRef = (0, react_native_reanimated_1.useAnimatedRef)();
    const [hover, setHover] = (0, react_1.useState)(false);
    const theme = (0, react_2.useTheme)();
    const handleClick = (0, debounce_1.debounceAfter)((event) => {
        onClick === null || onClick === void 0 ? void 0 : onClick(event, id);
    }, 100);
    const rippleColor = (0, react_1.useMemo)(() => {
        const val = new values_js_1.default(theme.palette[color].main);
        if ((0, color_1.isDark)(val.rgb)) {
            return val.tint(30).rgbString();
        }
        else {
            return val.shade(30).rgbString();
        }
    }, [color]);
    return (react_1.default.createElement(ListItemContainer, { "aria-label": "list-item", disabled: mode === 'view', onHoverIn: () => setHover(true), onHoverOut: () => setHover(false), color: color, hover: hover, selected: selected, style: [style === null || style === void 0 ? void 0 : style.container], onPress: (event) => handleClick(event), ref: rippleAnimationRef },
        react_1.default.createElement(RippleEffect_1.RippleEffect, { ref: rippleAnimationRef, color: rippleColor, style: {
                container: {
                    padding: theme.spacing.md,
                },
            } }, typeof children === 'string' ? (react_1.default.createElement(exports.ListItemView, null,
            react_1.default.createElement(exports.ListItemText, { color: color, size: size }, children))) : (children))));
};
exports.ListItem = ListItem;
const ListItemContainer = native_1.default.Pressable(({ theme, color, hover, selected }) => {
    return Object.assign(Object.assign({ borderBottomWidth: 1, borderColor: theme.palette.primary.light, backgroundColor: theme.palette.base.light }, (selected && {
        backgroundColor: theme.palette[color].light,
    })), (hover && {
        backgroundColor: theme.palette[color].light,
    }));
});
exports.ListItemView = native_1.default.View(() => {
    return {
        display: 'flex',
        flexDirection: 'row',
        alignItems: 'center',
    };
});
exports.ListItemText = native_1.default.Text(({ theme, size = 'md', color = 'primary' }) => {
    return Object.assign(Object.assign(Object.assign(Object.assign({ fontFamily: theme.fontFamily, paddingLeft: theme.spacing.sm, fontSize: theme.fontSize[size] }, (color === 'primary' && {
        color: theme.palette.text.main,
    })), (color === 'secondary' && {
        color: theme.palette.secondary.dark,
    })), (color === 'negative' && {
        color: theme.palette.negative.dark,
    })), (color === 'positive' && {
        color: theme.palette.positive.dark,
    }));
});
